/*
 * Copyright 2020,2021 Sony Corporation
 */

#include <stdio.h>
#include <command.h>
#include <debug_impl.h>
#include <sony_panel.h>

int do_paneldet_callback(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	int ret = -1;

	ret = paneldet_callback();
	if (ret != 0) {
		printf("failed to set sony panel to bootargs.\n");
		return CMD_RET_FAILURE;
	}
	return CMD_RET_SUCCESS;
}

int do_paneldet_power_set(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	int ret = -1;
	bool enable;

	if (argv[1][0] == '0')
		enable = false;
	else
		enable = true;

	ret = paneldet_setPanelPower(enable);
	if (ret != 0) {
		printf("failed to set sony panel power.\n");
		return CMD_RET_FAILURE;
	}
	return CMD_RET_SUCCESS;
}

int do_paneldet_backlight_set(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	int ret = -1;
	bool enable;

	if (argv[1][0] == '0')
		enable = false;
	else
		enable = true;

	ret = paneldet_setBacklightPower(enable);
	if (ret != 0) {
		printf("failed to set sony backlight power.\n");
		return CMD_RET_FAILURE;
	}
	return CMD_RET_SUCCESS;
}

U_BOOT_CMD(
	paneldet_callback, CONFIG_SYS_MAXARGS, 0, do_paneldet_callback,
	"Read panel ID and call autodet functions for the panel with panel and backlight power enable.",
	NULL
);

U_BOOT_CMD(
	panel_power_set, CONFIG_SYS_MAXARGS, 0, do_paneldet_power_set,
	"Set panel or 12V power IOs with delay.",
	"0: Power OFF, Otherwise: Power ON"
);

U_BOOT_CMD(
	backlight_power_set, CONFIG_SYS_MAXARGS, 0, do_paneldet_backlight_set,
	"Set backlight or 24V power IOs with delay.",
	"0: Power OFF, Otherwise: Power ON"
);
