/* SPDX-License-Identifier: (GPL-2.0 OR BSD-3-Clause) */
/*
 * Copyright (c) 2020 MediaTek Inc.
 */

#ifndef _MTK_TV_TG_TBL_H_
#define _MTK_TV_TG_TBL_H_

#define REG_MASK_ALL	Fld(16, 0, AC_FULLW10)

struct default_trigger_gen {
	u32 addr;
	u32 val;
	u32 mask;
};

static struct default_trigger_gen tg_b2r[] = {
	{ (0xA3A4 << 9) + (0x41 << 2), 0x1FEA, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x45 << 2), 0x0004, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x46 << 2), 0x01F1, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x4E << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x4F << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x50 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x53 << 2), 0x2801, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x54 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x56 << 2), 0x0101, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x59 << 2), 0x1800, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x5C << 2), 0x0013, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x5D << 2), 0x4D75, REG_MASK_ALL },
};

static struct default_trigger_gen tg_ip[] = {
	{ (0xA3A4 << 9) + (0x61 << 2), 0x1FEA, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x62 << 2), 0x000A, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x63 << 2), 0x001C, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x64 << 2), 0x001C, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x65 << 2), 0x0198, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x66 << 2), 0x01F1, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x69 << 2), 0x01DE, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x6E << 2), 0x0002, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x6F << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x70 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x73 << 2), 0x2801, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x76 << 2), 0x0101, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x79 << 2), 0x1800, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x7C << 2), 0x0013, REG_MASK_ALL },
	{ (0xA3A4 << 9) + (0x7D << 2), 0x4485, REG_MASK_ALL },
};

static struct default_trigger_gen tg_op1[] = {
	{ (0xA3A5 << 9) + (0x01 << 2), 0x1FE4, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x02 << 2), 0x0030, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x03 << 2), 0x0039, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x04 << 2), 0x0039, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x05 << 2), 0x008D, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x06 << 2), 0x00B9, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x09 << 2), 0x00D3, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x0E << 2), 0x000C, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x0F << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x10 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x13 << 2), 0x2801, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x14 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x16 << 2), 0x0101, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x19 << 2), 0x1800, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x1C << 2), 0x0013, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x1D << 2), 0x4C01, REG_MASK_ALL },
};

static struct default_trigger_gen tg_op2[] = {
	{ (0xA3A5 << 9) + (0x21 << 2), 0x1FE4, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x22 << 2), 0x0032, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x23 << 2), 0x003B, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x24 << 2), 0x003B, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x25 << 2), 0x008D, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x26 << 2), 0x00B9, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x29 << 2), 0x00D3, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x2E << 2), 0x0013, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x2F << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x30 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x33 << 2), 0x2801, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x34 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x36 << 2), 0x0101, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x39 << 2), 0x1800, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x3C << 2), 0x0013, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x3D << 2), 0x4C01, REG_MASK_ALL },
};

static struct default_trigger_gen tg_frc1[] = {
	{ (0xA3A5 << 9) + (0x61 << 2), 0x1FE4, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x62 << 2), 0x002C, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x63 << 2), 0x0035, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x64 << 2), 0x0035, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x65 << 2), 0x008D, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x66 << 2), 0x00B9, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x6E << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x6F << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x70 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x73 << 2), 0x0401, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x74 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x76 << 2), 0x0101, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x79 << 2), 0x1800, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x7C << 2), 0x0013, REG_MASK_ALL },
	{ (0xA3A5 << 9) + (0x7D << 2), 0x0D05, REG_MASK_ALL },
};

static struct default_trigger_gen tg_frc2[] = {
	{ (0xA3A6 << 9) + (0x01 << 2), 0x0004, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x02 << 2), 0x002C, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x03 << 2), 0x0035, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x04 << 2), 0x0035, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x05 << 2), 0x008D, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x06 << 2), 0x00B9, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x0E << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x0F << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x10 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x13 << 2), 0x0401, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x14 << 2), 0x0001, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x16 << 2), 0x0101, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x19 << 2), 0x1800, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x1C << 2), 0x0013, REG_MASK_ALL },
	{ (0xA3A6 << 9) + (0x1D << 2), 0x0D05, REG_MASK_ALL },
};

static struct default_trigger_gen tg_frc_in[] = {
	{ (0x8502 << 9) + (0x61 << 2), 0x1FE4, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x62 << 2), 0x002C, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x63 << 2), 0x0035, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x64 << 2), 0x0035, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x65 << 2), 0x008D, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x66 << 2), 0x00B9, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x67 << 2), 0x0007, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x68 << 2), 0x002D, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x6E << 2), 0x0002, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x6F << 2), 0x0001, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x73 << 2), 0x0401, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x74 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x76 << 2), 0x0101, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x79 << 2), 0x1200, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x7C << 2), 0x0013, REG_MASK_ALL },
	{ (0x8502 << 9) + (0x7D << 2), 0x4E15, REG_MASK_ALL },
};

static struct default_trigger_gen tg_frc_stage[] = {
	{ (0x8503 << 9) + (0x21 << 2), 0x0004, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x23 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x24 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x25 << 2), 0x002C, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x26 << 2), 0x0009, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x27 << 2), 0x0004, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x2E << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x2F << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x30 << 2), 0x000F, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x33 << 2), 0x0401, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x34 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x36 << 2), 0x0101, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x39 << 2), 0x1800, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x3C << 2), 0x0013, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x3D << 2), 0x0D75, REG_MASK_ALL },
};

static struct default_trigger_gen tg_frc_me[] = {
	{ (0x8503 << 9) + (0x61 << 2), 0x0004, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x63 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x64 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x65 << 2), 0x0035, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x66 << 2), 0x0009, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x67 << 2), 0x0004, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x6E << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x6F << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x70 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x73 << 2), 0x3F01, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x74 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x76 << 2), 0x0101, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x79 << 2), 0x1800, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x7C << 2), 0x0013, REG_MASK_ALL },
	{ (0x8503 << 9) + (0x7D << 2), 0x0D75, REG_MASK_ALL },
};

static struct default_trigger_gen tg_frc_mi[] = {
	{ (0x8504 << 9) + (0x01 << 2), 0x0004, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x03 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x04 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x05 << 2), 0x00B9, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x06 << 2), 0x00BA, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x07 << 2), 0x0004, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x08 << 2), 0x00B9, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x0E << 2), 0x0001, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x0F << 2), 0x0001, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x10 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x13 << 2), 0x0401, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x14 << 2), 0x0001, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x16 << 2), 0x0101, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x19 << 2), 0x1800, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x1C << 2), 0x0013, REG_MASK_ALL },
	{ (0x8504 << 9) + (0x1D << 2), 0x0D75, REG_MASK_ALL },
};

#endif

